import { __awaiter, __generator, __values } from "tslib";
import { isLoaderRequestElement } from "../../../types";
import { ModulePrefix } from "../../../";
import Meta from "../../meta";
import pickMetaSource from "../../PickMetaSource";
import buildComputed from "../builders/Computed";
import ResolveRoute from "../../../util/ResolveRoute";
var buildCreated = function (loaderRequest) {
    return function () {
        return __awaiter(this, void 0, void 0, function () {
            var isPost, contentType, requests, loaderRequest_1, loaderRequest_1_1, request;
            var e_1, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(typeof loaderRequest === "string")) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.$store.dispatch(ModulePrefix + "_post/load", {
                                slug: ResolveRoute(loaderRequest, this.$route),
                                type: "pages",
                                embed: false
                            })];
                    case 1:
                        _b.sent();
                        return [3 /*break*/, 7];
                    case 2:
                        if (!isLoaderRequestElement(loaderRequest)) return [3 /*break*/, 4];
                        isPost = "type" in loaderRequest;
                        contentType = isPost ? loaderRequest.type : "pages";
                        return [4 /*yield*/, this.$store.dispatch(ModulePrefix + "_post/load", {
                                slug: ResolveRoute(loaderRequest.slug, this.$route),
                                type: contentType,
                                embed: loaderRequest.hasOwnProperty("embed")
                            })];
                    case 3:
                        _b.sent();
                        return [3 /*break*/, 7];
                    case 4:
                        if (!Array.isArray(loaderRequest)) return [3 /*break*/, 6];
                        requests = [];
                        try {
                            for (loaderRequest_1 = __values(loaderRequest), loaderRequest_1_1 = loaderRequest_1.next(); !loaderRequest_1_1.done; loaderRequest_1_1 = loaderRequest_1.next()) {
                                request = loaderRequest_1_1.value;
                                if (typeof request !== "string" && !isLoaderRequestElement(request)) {
                                    throw new Error("FetchHookType Created: Bad loaderRequest");
                                }
                                requests.push(buildCreated.call(this, request).call(this));
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (loaderRequest_1_1 && !loaderRequest_1_1.done && (_a = loaderRequest_1.return)) _a.call(loaderRequest_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        return [4 /*yield*/, Promise.all(requests)];
                    case 5:
                        _b.sent();
                        return [3 /*break*/, 7];
                    case 6: throw new Error("FetchHookTypeCreated: loaderRequest cannot be " + typeof loaderRequest);
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
};
export default (function (loaderRequest, setMeta) {
    var returnable = {
        created: buildCreated(loaderRequest),
        computed: buildComputed(loaderRequest)
    };
    if (setMeta) {
        var _a = pickMetaSource(loaderRequest), type = _a.type, slug = _a.slug;
        returnable.mixins = [
            Meta(type, slug, typeof setMeta === "boolean" ? undefined : setMeta)
        ];
    }
    return returnable;
});
//# sourceMappingURL=Created.js.map