import { __assign, __awaiter, __generator, __values } from "tslib";
import { ModulePrefix } from './../../index';
import axios from "axios";
import * as types from "./mutation-types";
import { UrlCreator } from "../../util/UrlCreator";
var typeBaseUrl = "/wp-json/menus/v1/menus";
export var actions = {
    load: function (_a, _b) {
        var rootState = _a.rootState, commit = _a.commit, state = _a.state;
        var menuSlugs = _b.menuSlugs;
        return __awaiter(this, void 0, void 0, function () {
            var config, prefix, base, fixUrls, requests, menuSlugs_1, menuSlugs_1_1, slug, hasMenu, response, hasMenu, response, firstResponse, slugs, requests, slugs_1, slugs_1_1, slug, hasMenu, response, err_1;
            var e_1, _c, e_2, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        if (menuSlugs === false) {
                            return [2 /*return*/];
                        }
                        config = rootState[ModulePrefix + "_config"];
                        if (config.requestPrefix) {
                            prefix = config.requestPrefix;
                            if (prefix.endsWith("/")) {
                                prefix = prefix.substring(0, -1);
                            }
                            if (prefix.startsWith("/")) {
                                prefix = prefix.substr(1);
                            }
                            typeBaseUrl = "/" + prefix + typeBaseUrl;
                        }
                        base = new UrlCreator(config.url, [typeBaseUrl]);
                        fixUrls = function (itemsBefore) {
                            var e_3, _a;
                            var fixedItems = [];
                            // If itemsBefore is Object, we have to convert it to array
                            var items = Array.isArray(itemsBefore)
                                ? itemsBefore
                                : Object.values(itemsBefore);
                            var _loop_1 = function (item) {
                                var prefix = item.object == "page" ? "page" : "post";
                                fixedItems.push(__assign(__assign({}, item), { url: item.url.replace(config.url, function (k) {
                                        return config.url.substr(-1) === "/" ? "/" + prefix + "/" : prefix + "/";
                                    }) }));
                            };
                            try {
                                for (var items_1 = __values(items), items_1_1 = items_1.next(); !items_1_1.done; items_1_1 = items_1.next()) {
                                    var item = items_1_1.value;
                                    _loop_1(item);
                                }
                            }
                            catch (e_3_1) { e_3 = { error: e_3_1 }; }
                            finally {
                                try {
                                    if (items_1_1 && !items_1_1.done && (_a = items_1.return)) _a.call(items_1);
                                }
                                finally { if (e_3) throw e_3.error; }
                            }
                            return fixedItems;
                        };
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 9, , 10]);
                        if (!Array.isArray(menuSlugs)) return [3 /*break*/, 3];
                        requests = [];
                        try {
                            for (menuSlugs_1 = __values(menuSlugs), menuSlugs_1_1 = menuSlugs_1.next(); !menuSlugs_1_1.done; menuSlugs_1_1 = menuSlugs_1.next()) {
                                slug = menuSlugs_1_1.value;
                                hasMenu = state.menu[slug];
                                if (hasMenu) {
                                    if (config.debugger) {
                                        console.log("[VueWordpress][Debugger] Omits " + slug + " menu because it has been fetched yet");
                                    }
                                    continue;
                                }
                                base.addAtTheEnd(slug);
                                requests.push(axios.get(base.url));
                                base.removeFromTheEnd();
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (menuSlugs_1_1 && !menuSlugs_1_1.done && (_c = menuSlugs_1.return)) _c.call(menuSlugs_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        return [4 /*yield*/, Promise.all(requests)];
                    case 2:
                        response = _e.sent();
                        response.forEach(function (c) {
                            commit(types.SET_MENU_CONTENT, {
                                data: __assign(__assign({}, c.data), { items: fixUrls(c.data.items) }),
                                slotName: c.data.slug
                            });
                        });
                        return [3 /*break*/, 8];
                    case 3:
                        if (!(typeof menuSlugs === "string")) return [3 /*break*/, 5];
                        hasMenu = state.menu[menuSlugs];
                        if (hasMenu) {
                            if (config.debugger) {
                                console.log("[VueWordpress][Debugger] Omits " + menuSlugs + " menu because it has been fetched yet");
                            }
                            return [2 /*return*/];
                        }
                        base.addAtTheEnd(menuSlugs);
                        return [4 /*yield*/, axios.get(base.url)];
                    case 4:
                        response = _e.sent();
                        commit(types.SET_MENU_CONTENT, {
                            data: __assign(__assign({}, response.data), { items: fixUrls(response.data.items) }),
                            slotName: menuSlugs
                        });
                        return [3 /*break*/, 8];
                    case 5:
                        if (!(menuSlugs === true)) return [3 /*break*/, 8];
                        return [4 /*yield*/, axios.get(base.url)];
                    case 6:
                        firstResponse = _e.sent();
                        slugs = firstResponse.data.map(function (v) { return v.slug; });
                        requests = [];
                        try {
                            for (slugs_1 = __values(slugs), slugs_1_1 = slugs_1.next(); !slugs_1_1.done; slugs_1_1 = slugs_1.next()) {
                                slug = slugs_1_1.value;
                                hasMenu = state.menu[slug];
                                if (hasMenu) {
                                    if (config.debugger) {
                                        console.log("[VueWordpress][Debugger] Omits " + slug + " menu because it has been fetched yet");
                                    }
                                    continue;
                                }
                                base.addAtTheEnd(slug);
                                requests.push(axios.get(base.url));
                                base.removeFromTheEnd();
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (slugs_1_1 && !slugs_1_1.done && (_d = slugs_1.return)) _d.call(slugs_1);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                        return [4 /*yield*/, Promise.all(requests)];
                    case 7:
                        response = _e.sent();
                        response.forEach(function (c) {
                            commit(types.SET_MENU_CONTENT, {
                                data: __assign(__assign({}, c.data), { items: fixUrls(c.data.items) }),
                                slotName: c.data.slug
                            });
                        });
                        _e.label = 8;
                    case 8: return [3 /*break*/, 10];
                    case 9:
                        err_1 = _e.sent();
                        console.error(err_1);
                        return [3 /*break*/, 10];
                    case 10: return [2 /*return*/];
                }
            });
        });
    }
};
//# sourceMappingURL=actions.js.map